#include <sourcemod>

// Время до вызова функции Finish_Func в секундах
new FINISH_SEC = 60;

new index;

new money[MAXPLAYERS+1];
// Если игрок выйдет и не задет в течение DEL_SEC секунд, то FINISH_SEC сбросится для него.
new DEL_SEC = 10;

// Тут храним секунды (сколько осталось до вызова функции Finish_Func)
// Ключ - стим, значение ключа - секунды
new Handle:TrieSec;

// Тут храним Handle таймера (DEL_SEC), который запускается после выхода игрока.
// Ключ - стим, значение ключа - Handle
new Handle:TrieDel;

new Handle:TrieSteam;

new Handle:my_timer[MAXPLAYERS+1];

new my_join_time[MAXPLAYERS+1];

public OnPluginStart()
{
	TrieSec = CreateTrie();
	TrieSteam = CreateTrie();
	TrieDel = CreateTrie();
	HookEvent("player_spawn", player_spawn, EventHookMode_Post);
	HookEvent("round_start", EventRoundStart);
}

public OnClientPutInServer(client)
{
	if (!IsFakeClient(client))
	{
		decl String:SteaM[25];
		GetClientAuthString(client, SteaM, 25);
		my_join_time[client] = GetTime();

		new sec;
		if (GetTrieValue(TrieSec, SteaM, sec))
		{
			GetTrieValue(TrieSteam, SteaM, money[client])
			// Игрок выходил и успел зайти в течение DEL_SEC
			// Запускаем его таймер
			my_timer[client] = CreateTimer(float(sec), Finish_Func, client);
			PrintToChat(client, "Finish_Func сработает через: %d сек", sec);

			// Убиваем таймер, который был запущен на DEL_SEC
			new Handle:timer;
			if (GetTrieValue(TrieDel, SteaM, timer))
			{
				KillTimer(timer);
				RemoveFromTrie(TrieDel, SteaM);
			}
		}
		else
		{
			// игрок или 1 раз вошел или не успел в течение DEL_SEC - запускаем таймер на FINISH_SEC сек
			SetTrieValue(TrieSec, SteaM, FINISH_SEC);
			my_timer[client] = CreateTimer(float(FINISH_SEC), Finish_Func, client);
			PrintToChat(client, "Finish_Func сработает через: %d сек", FINISH_SEC);
			money[client] = 0;
		}
	}
}

public Action:player_spawn(Handle:event, const String:name[], bool:dontBroadcast)  
{
	new id = GetEventInt(event, "userid"); 
	index = GetClientOfUserId(id); 	
}

public EventRoundStart(Handle:event, const String:name[], bool:dontBroadcast) 
{
		if (money[index] == 1)
		{
			new cash = GetEntProp(index, Prop_Send, "m_iAccount") + 1000;
			if (cash > 16000) cash = 16000;
			SetEntProp(index, Prop_Send, "m_iAccount", cash);
			PrintToChat(index,"%d", cash);
		}
		if (money[index] == 2)
		{
			new cash = GetEntProp(index, Prop_Send, "m_iAccount") + 2000;
			if (cash > 16000) cash = 16000;
			SetEntProp(index, Prop_Send, "m_iAccount", cash);
			PrintToChat(index,"%d", cash);
		}
		if (money[index] == 3)
		{
			new cash = GetEntProp(index, Prop_Send, "m_iAccount") + 3000;
			if (cash > 16000) cash = 16000;
			SetEntProp(index, Prop_Send, "m_iAccount", cash);
			PrintToChat(index,"%d", cash);
		}
		if (money[index] >= 4)
		{
			new cash = GetEntProp(index, Prop_Send, "m_iAccount") + 4000;
			if (cash > 16000) cash = 16000;
			SetEntProp(index, Prop_Send, "m_iAccount", cash);
			PrintToChat(index,"%d", cash);
		}
}

public OnClientDisconnect(client)
{
	if (my_timer[client] != INVALID_HANDLE)
	{
		KillTimer(my_timer[client]);
		my_timer[client] = INVALID_HANDLE;

		decl String:SteaM[25];
		GetClientAuthString(client, SteaM, 25);
		new sec;
		GetTrieValue(TrieSec, SteaM, sec);

		// сколько сек игрок провел в игре
		new in_game_sec = GetTime() - my_join_time[client];

		// вычитаем и получаем оставшиеся секунды до срабатывания Finish_Func
		sec -= in_game_sec;

		SetTrieValue(TrieSec, SteaM, sec);

		new Handle:timer, Handle:pack;
		timer = CreateDataTimer(float(DEL_SEC), DEL_SEC_Func, pack);
		WritePackString(pack, SteaM);

		SetTrieValue(TrieDel, SteaM, timer);
		SetTrieValue(TrieSteam, SteaM, money[client]);
		money[client] = 0;
	}
}

public Action:DEL_SEC_Func(Handle:timer, Handle:pack)
{
	decl String:SteaM[25];
	ResetPack(pack);
	ReadPackString(pack, SteaM, 25);
	RemoveFromTrie(TrieSec, SteaM);
	RemoveFromTrie(TrieDel, SteaM);
	RemoveFromTrie(TrieSteam, SteaM);
	PrintToServer("-----> DEL_SEC_Func: %s удален", SteaM);
}

public Action:Finish_Func(Handle:timer, any:client)
{
		decl String:SteaM[25];
		GetClientAuthString(client, SteaM, 25);
		SetTrieValue(TrieSec, SteaM, FINISH_SEC);
		my_join_time[client] = GetTime();
		my_timer[client] = CreateTimer(float(FINISH_SEC), Finish_Func, client);

		PrintToChat(client, "Finish_Func сработает через: %d сек", FINISH_SEC);
		PrintToChatAll("\x04Finish_Func");
		PrintToServer("-----> Finish_Func");
		money[client] += 1;
}